package metrics;

import java.util.HashMap;

import javax.swing.JFrame;

import testapp.Dictionary;
import testapp.Dictionary.Bundle;
import testapp.JOptionDialog;

/**
 * Bray-Curtis distance metric
 * 
 * @author Tobies
 * 
 */
public class BrayCurtisMetric extends DistanceMetric {

	protected BrayCurtisMetric() {
		super(null);
	}

	protected BrayCurtisMetric(HashMap<String, Object> map) {
		super(map);
	}

	@Override
	protected double innerCalculate(double[] input1, double[] input2) {
		double sum = 0D;
		for (int i = 0; i < input1.length; i++) {
			if (!(input1[i] == 0 && input2[i] == 0))
				sum += Math.abs(input1[i] - input2[i]) 	/ (input1[i] + input2[i]);
		}
		return sum;
	}

	@Override
	protected double innerCalculate(int[] input1, int[] input2) {
		double sum = 0D;
		for (int i = 0; i < input1.length; i++) {
			if (!(input1[i] == 0 && input2[i] == 0))
				sum += Math.abs(input1[i] - input2[i])
						/ (input1[i] + input2[i]);
		}
		return sum;
	}

	@Override
	public String getName() {
		return Dictionary.get(Bundle.METRIC, "braycurtis");
	}
	@Override
	public String toString(){
		return getName();
	}

	@Override
	public JOptionDialog getOptionsDialog(JFrame parent) {
		return null;
	}

}
