package metrics;


import java.util.HashMap;

import javax.swing.JFrame;

import testapp.Dictionary;
import testapp.JOptionDialog;
import testapp.Dictionary.Bundle;


/**
 * Canberra distance metric
 * 
 * @author Tobies
 * 
 */
public class CanberraMetric extends DistanceMetric {

	protected CanberraMetric() {
		super(null);
	}

	protected CanberraMetric(HashMap<String, Object> map) {
		super(map);
	}

	@Override
	protected double innerCalculate(double[] input1, double[] input2) {
		Double sum = 0D;
		for (int i = 0; i < input1.length; i++) {
			if (!(input1[i] == 0 && input2[i] == 0))
				sum += Math.abs(input1[i] - input2[i])
						/ (Math.abs(input1[i]) + Math.abs(input2[i]));
		}
		return sum;
	}

	@Override
	protected double innerCalculate(int[] input1, int[] input2) {
		Double sum = 0D;
		for (int i = 0; i < input1.length; i++) {
			if (!(input1[i] == 0 && input2[i] == 0))
				sum += Math.abs(input1[i] - input2[i])
						/ (Math.abs(input1[i]) + Math.abs(input2[i]));
		}
		return sum;
	}

	@Override
	public String getName() {
		return Dictionary.get(Bundle.METRIC, "chiquadrat");
	}
	
	@Override
	public String toString(){
		return getName();
	}

	@Override
	public JOptionDialog getOptionsDialog(JFrame parent) {
		return null;
	}

}
