package metrics;


import java.util.HashMap;

import javax.swing.JFrame;

import testapp.Dictionary;
import testapp.JOptionDialog;
import testapp.Dictionary.Bundle;


/**
 * Jeffrey divergence
 * 
 * @author Tobies
 * 
 */
public class JeffreyMetric extends DistanceMetric {

	protected JeffreyMetric() {
		super(null);
	}

	protected JeffreyMetric(HashMap<String, Object> map) {
		super(map);
	}

	@Override
	protected double innerCalculate(double[] input1, double[] input2) {
		Double sum = 0D;
		for (int i = 0; i < input1.length; i++) {
			if (!(input1[i] == 0 && input2[i] == 0)) {
				double m = (input1[i] + input2[i]) / 2;
				if (input1[i] > 0) {
					sum += input1[i] * Math.log(input1[i] / m);
				}
				if (input2[i] > 0) {
					sum += input2[i] * Math.log(input2[i] / m);
				}
			}
		}
		return sum;
	}

	@Override
	protected double innerCalculate(int[] input1, int[] input2) {
		Double sum = 0D;
		for (int i = 0; i < input1.length; i++) {
			if (!(input1[i] == 0 && input2[i] == 0)) {
				double m = (input1[i] + input2[i]) / 2;
				if (input1[i] > 0) {
					sum += input1[i] * Math.log(input1[i] / m);
				}
				if (input2[i] > 0) {
					sum += input2[i] * Math.log(input2[i] / m);
				}
			}
		}
		return sum;
	}

	@Override
	public String getName() {
		return Dictionary.get(Bundle.METRIC, "jeffrey");
	}
	
	@Override
	public String toString(){
		return getName();
	}
	
	@Override
	public JOptionDialog getOptionsDialog(JFrame parent) {
		return null;
	}
}
