package metrics;


import java.util.HashMap;

import javax.swing.JFrame;

import testapp.Dictionary;
import testapp.Dictionary.Bundle;
import testapp.JOptionDialog;


public class QuadraticMetric extends DistanceMetric {

	protected QuadraticMetric() {
		super(null);
	}

	protected QuadraticMetric(HashMap<String, Object> map) {
		super(map);
	}

	@Override
	protected double innerCalculate(double[] input1, double[] input2) {
		int size = input1.length;
		double max = 0;
		double[] distances = new double[size];
		// Distances for dimensions, max distance
		for (int i = 0; i < size; i++) {
			distances[i] = Math.abs(input1[i] - input2[i]);
			if (distances[i] > max)
				max = distances[i];
		}
		// matrix
		double[][] matrix = new double[size][size];
		for (int i = 0; i < size; i++) {
			for (int j = 0; j < size; j++) {
				matrix[i][j] = 1 - (distances[i] / max);
			}
		}
		// multiplication
		double[] mem = new double[size];
		for (int i = 0; i < size; i++) {
			for (int j = 0; j < size; j++) {
				mem[i] += distances[j] * matrix[j][i];				
			}
		}
		double res = 0D;
		for (int i = 0; i < size; i++) {
			res += mem[i] * distances[i];
		}
		return Math.sqrt(res);
	}

	@Override
	protected double innerCalculate(int[] input1, int[] input2) {
		int size = input1.length;
		double max = 0;
		double[] distances = new double[size];
		// Distances for dimensions, max distance
		for (int i = 0; i < size; i++) {
			distances[i] = Math.abs(input1[i] - input2[i]);
			if (distances[i] > max)
				max = distances[i];
		}
		// matrix
		double[][] matrix = new double[size][size];
		for (int i = 0; i < size; i++) {
			for (int j = 0; j < size; j++) {
				matrix[i][j] = 1 - (distances[i] / max);
			}
		}
		// multiplication
		double[] mem = new double[size];
		for (int i = 0; i < size; i++) {
			for (int j = 0; j < size; j++) {
				mem[i] += distances[j] * matrix[j][i];				
			}
		}
		double res = 0D;
		for (int i = 0; i < size; i++) {
			res += mem[i] * distances[i];
		}
		return Math.sqrt(res);
	}

	@Override
	public String getName() {
		return Dictionary.get(Bundle.METRIC, "quadratic");
	}
	
	@Override
	public String toString(){
		return getName();
	}
	
	@Override
	public JOptionDialog getOptionsDialog(JFrame parent) {
		return null;
	}
}
